/* Alg lui Floyd-Warshall ( Roy-Floyd)
 * 
 * Determina distanta minima intre oricare doua noduri
 * intr-un garf ponderat
 * 
 * F-W : transforma matr ponderilor in matricea costurilo minime ale lanturilor
 * 
 */ 
#include <fstream>
#include <vector>
#include <queue>
using namespace std;

ifstream fin("graf2.in");
ofstream fout("graf2.out");

const int N = 101, Inf = 0x3f3f3f3f;
int c[N][N]; // matricea ponderilor muchiiilor = se va transforma in matricea
             // dist minime (a costurilor minime ale lanturilor(
int n;

void ReadGraph();
void Floyd_Warshall();
void WriteMatrix();

int main()
{
	ReadGraph();
	WriteMatrix(); // matrice de adiacenta
	
	Floyd_Warshall();

	WriteMatrix(); // matrice lanturilor
	return 0;
}

void Floyd_Warshall() // O(n^3)
{
	for (int k = 1; k <= n; ++k)
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				if (i != j && c[i][k] + c[k][j] < c[i][j])
					c[i][j] = c[i][k] + c[k][j]; 
}

void ReadGraph()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (i != j)
				c[i][j] = Inf;
	
	int x, y, w;
	while (fin >> x >> y >> w)
		c[x][y] = c[y][x] = w;
}

void WriteMatrix()
{
	for (int i = 1; i <= n; ++i, fout << '\n')
		for (int j = 1; j<= n; ++j)
			fout << c[i][j] << ' ';
	fout << "\n\n";
}

