/* Alg lui Warshall
 * Determina pt oricare pereche de noduri x, y
 * din graf daca exista sau nu un lant care le uneste
 * 
 * matr de adiacenta  => matr lanturilor
 */ 
#include <fstream>
using namespace std;

ifstream fin("warshall.in");
ofstream fout("warshall.out");

const int N = 101;
int a[N][N], n;

void CitesteGraf();
void Warshall();
void ScrieMatrice();

int main()
{
	CitesteGraf();
	ScrieMatrice();  // matricea de adiacenta
	Warshall();
	ScrieMatrice();  // matricea lanturilor
}

void CitesteGraf()
{
	fin >> n;
	int x, y;
	while (fin >> x >> y)
	{
		a[x][y] = 1;
	//	a[y][x] = 1;
	}
}

void Warshall() // O(n^3)
{
	for (int k = 1; k <= n; ++k)
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				if (i != j && a[i][j] == 0)
					a[i][j] = a[i][k] * a[k][j];
}

void ScrieMatrice()
{
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= n; ++j)
			fout << a[i][j] << ' ';
		fout << '\n';
	}
	
	fout << "\n\n";
}




