#include <iomanip>
#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
using namespace std;

ifstream fin("4.IN");
ofstream fout("LOC.out");

#define INF 0x3f3f3f3f
#define pb push_back
#define mp make_pair

typedef set<pair<int, int> > SP;
typedef SP::iterator IT;
typedef vector<int> VI;
VI G[101], C[101];
SP T;
IT it;
int d[101], nr[101], n, m;

void Read();
void Dijkstra(int src);
void Write();

int main()
{
	Read();
	Dijkstra(0);
	Write();
	
	fin.close();
	fout.close();
}

void Read()
{
	fin >> n >> m;
	int x, y, z;
	while ( m-- )
	{
		fin >> x >> y >> z;
		G[x].pb(y);
		G[y].pb(x);
		C[x].pb(z);
		C[y].pb(z);
	}
}

bool out[200];
void Dijkstra(int src)
{
	for ( int i = 0; i <= n; ++i )
		d[i] = INF;
	nr[src] = 1;
	d[src] = 0;
	T.insert(make_pair(0, src));
	int nod, y;

	while ( !T.empty() )
	{
		nod = T.begin()->second;
		T.erase(T.begin());
	//	out[nod] = true;
		for ( int i = 0; i < (int)G[nod].size(); ++i )
		{
			y = G[nod][i];
			
	//		if ( out[y] ) continue;	
			if ( d[y] > d[nod] + C[nod][i] ) 
			{		
				it = T.find(mp(d[y], y)); // vechiul d[y]
				d[y] = d[nod] + C[nod][i];
				nr[y] = nr[nod];
				
				if ( it != T.end() )
					T.erase(it);
				T.insert(make_pair(d[y], y));
			}
			else
				if ( d[y] == d[nod] + C[nod][i] )
					nr[y] += nr[nod];
		}
	}
}

void Write()
{
	int nod, maxim = -1;

	for ( int i = 1; i <= n; ++i )
		if ( nr[i] > maxim )
		{
			nod = i;
			maxim = nr[i];
		}
	
	fout << nod << '\n' << maxim << '\n' << d[nod];
}
