#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

ifstream fin("h1.in");
ofstream fout("rj.out");

const int Inf = 0x3f3f3f3f;

using VI  = vector<int>;
using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;
using VB  = vector<bool>;

VVP G;
int n, m;
int R, J, B, S;
VI tr; // timpii minimi ai lui Romeo
VI tj; // timpii minimi ai lui Julieta
VB vj, vr; // nodurile prin care poate trece Julieta/Romeo

void Dijkstra(int x, VI& d);
void Dfs(int x, VI& d, VB& v);

int main()
{
	int x, y, w;
	while (true)
	{
		fin >> n;
		if (n == -1)
			break;
		fin >> m;
		fin >> J >> B >> R >> S;
		
		G = VVP(n + 1); // G[0], G[1], 
		vj = vr = VB(n + 1);
		while (m--)
		{
			fin >> x >> y >> w;
			G[x].emplace_back(y, w);
			G[y].emplace_back(x, w);
		}
		
		Dijkstra(J, tj);
		Dijkstra(R, tr);
		Dfs(B, tj, vj);
		Dfs(S, tr, vr);
		int tmin = Inf;
		for (int nod = 1; nod <= n; ++nod)
			if (vr[nod] && vj[nod] && tr[nod] == tj[nod] && tr[nod] < tmin)
				tmin = tr[nod];
				
		if (tmin != Inf)
			fout << tmin << '\n';
		else
			fout << -1 << '\n';
	}
}

void Dijkstra(int x, VI& d)
{
	priority_queue<PI, vector<PI>, greater<PI>> Q;
	d = VI(n + 1, Inf);
	d[x] = 0;
	Q.emplace(0, x);
	
	while (!Q.empty())
	{
		auto [dx, x] = Q.top();
		Q.pop();	
		if (dx > d[x]) continue;
		
		for (auto [y, w] : G[x])
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				Q.emplace(d[y], y);
			}
	}
}

void Dfs(int x, VI& d, VB& v)
{
	v[x] = true;
	for (auto [y, w] : G[x])
		if (!v[y] && d[y] + w == d[x])
			Dfs(y, d, v);
}
